Close file descriptor on error handling.
[oweals/gnunet.git] / src / credential / test_credential_verify_and.sh
1 #!/bin/bash
2 trap "gnunet-arm -e -c test_credential_lookup.conf" SIGINT
3
4 LOCATION=$(which gnunet-config)
5 if [ -z $LOCATION ]
6 then
7   LOCATION="gnunet-config"
8 fi
9 $LOCATION --version 1> /dev/null
10 if test $? != 0
11 then
12         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
13         exit 77
14 fi
15
16 rm -rf `gnunet-config -c test_credential_lookup.conf -s PATHS -o GNUNET_HOME -f`
17
18 #  (1) Service.user -> GNU.project.member
19 #  (2) GNU.project -> GNUnet
20 #  (3) GNUnet.member -> GNUnet.developer
21 #  (4) GNUnet.member -> GNUnet.user
22 #  (5) GNUnet.developer -> Alice
23
24
25 which timeout &> /dev/null && DO_TIMEOUT="timeout 30"
26 gnunet-arm -s -c test_credential_lookup.conf
27 gnunet-identity -C service -c test_credential_lookup.conf
28 gnunet-identity -C alice -c test_credential_lookup.conf
29 gnunet-identity -C gnu -c test_credential_lookup.conf
30 gnunet-identity -C gnunet -c test_credential_lookup.conf
31
32 GNU_KEY=$(gnunet-identity -d -c test_credential_lookup.conf | grep gnu | grep -v gnunet | awk '{print $3}')
33 ALICE_KEY=$(gnunet-identity -d -c test_credential_lookup.conf | grep alice | awk '{print $3}')
34 GNUNET_KEY=$(gnunet-identity -d -c test_credential_lookup.conf | grep gnunet | awk '{print $3}')
35 SERVICE_KEY=$(gnunet-identity -d -c test_credential_lookup.conf | grep service | awk '{print $3}')
36
37 USER_ATTR="user"
38 GNU_PROJECT_ATTR="project"
39 MEMBER_ATTR="member"
40 DEVELOPER_ATTR="developer"
41 DEV_ATTR="developer"
42 TEST_CREDENTIAL="mygnunetcreds"
43
44 # (1) A service assigns the attribute "user" to all entities that have been assigned "member" by entities that werde assigned "project" from GNU
45 gnunet-namestore -p -z service -a -n $USER_ATTR -t ATTR -V "$GNU_KEY $GNU_PROJECT_ATTR.$MEMBER_ATTR" -e 5m -c test_credential_lookup.conf
46
47 # (2) GNU recognized GNUnet as a GNU project and delegates the "project" attribute
48 gnunet-namestore -p -z gnu -a -n $GNU_PROJECT_ATTR -t ATTR -V "$GNUNET_KEY" -e 5m -c test_credential_lookup.conf
49
50 # (3+4) GNUnet assigns the attribute "member" to all entities gnunet has also assigned "developer" or "user"
51 gnunet-namestore -p -z gnunet -a -n $MEMBER_ATTR -t ATTR -V "$GNUNET_KEY $DEVELOPER_ATTR,$GNUNET_KEY $USER_ATTR" -e 5m -c test_credential_lookup.conf
52
53 # (5) GNUnet issues Alice the credential "developer"
54 CRED1=`$DO_TIMEOUT gnunet-credential --issue --ego=gnunet --subject=$ALICE_KEY --attribute=$DEV_ATTR --ttl=5m -c test_credential_lookup.conf`
55 # (5) GNUnet issues Alice the credential "user"
56 CRED2=`$DO_TIMEOUT gnunet-credential --issue --ego=gnunet --subject=$ALICE_KEY --attribute=$USER_ATTR --ttl=5m -c test_credential_lookup.conf`
57 # Alice stores the credential under "mygnunetcreds"
58 gnunet-namestore -p -z alice -a -n $TEST_CREDENTIAL -t CRED -V "$CRED1" -e 5m -c test_credential_lookup.conf
59 gnunet-namestore -p -z alice -a -n $TEST_CREDENTIAL -t CRED -V "$CRED2" -e 5m -c test_credential_lookup.conf
60
61 CREDS=`$DO_TIMEOUT gnunet-credential --collect --issuer=$SERVICE_KEY --attribute=$USER_ATTR --ego=alice -c test_credential_lookup.conf | paste -d, -s`
62
63 #TODO2 Add -z swich like in gnunet-gns
64 RES_CRED=`gnunet-credential --verify --issuer=$SERVICE_KEY --attribute=$USER_ATTR --subject=$ALICE_KEY --credential="$CREDS" -c test_credential_lookup.conf`
65
66
67 #TODO cleanup properly
68 gnunet-namestore -z alice -d -n $TEST_CREDENTIAL -t CRED -e never -c test_credential_lookup.conf
69 gnunet-namestore -z gnu -d -n $GNU_PROJECT_ATTR -t ATTR -c test_credential_lookup.conf
70 gnunet-namestore -z gnunet -d -n $MEMBER_ATTR -t ATTR -c test_credential_lookup.conf
71 gnunet-namestore -z service -d -n $USER_ATTR -t ATTR -c test_credential_lookup.conf
72 gnunet-arm -e -c test_credential_lookup.conf
73
74 if [ "$RES_CRED" != "Failed." ]
75 then
76   echo -e "${RES_CRED}"
77   exit 0
78 else
79   echo "FAIL: Failed to verify credential $RES_CRED."
80   exit 1
81 fi